Index: vfs/ufs/ufs_quota.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ufs_quota.c,v
retrieving revision 1.11
diff -u -r1.11 ufs_quota.c
--- vfs/ufs/ufs_quota.c	23 Sep 2003 05:03:53 -0000	1.11
+++ vfs/ufs/ufs_quota.c	22 Feb 2004 21:58:04 -0000
@@ -380,9 +380,18 @@
  * Code to process quotactl commands.
  */
 
+struct scaninfo {
+	thread_t td;
+	int rescan;
+	int type;
+};
+
 /*
  * Q_QUOTAON - set up a quota file for a particular file system.
  */
+static int quotaon_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data);
+
 int
 quotaon(td, mp, type, fname)
 	struct thread *td;
@@ -392,11 +401,11 @@
 {
 	struct ufsmount *ump = VFSTOUFS(mp);
 	struct vnode *vp, **vpp;
-	struct vnode *nextvp;
 	struct dquot *dq;
 	int error;
 	struct nameidata nd;
 	struct ucred *cred;
+	struct scaninfo scaninfo;
 
 	KKASSERT(td->td_proc);
 	cred = td->td_proc->p_ucred;
@@ -408,7 +417,7 @@
 		return (error);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vp = nd.ni_vp;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (vp->v_type != VREG) {
 		(void) vn_close(vp, FREAD|FWRITE, td);
 		return (EACCES);
@@ -438,21 +447,13 @@
 	 * adding references to quota file being opened.
 	 * NB: only need to add dquot's for inodes being modified.
 	 */
-again:
-	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nextvp) {
-		nextvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		if (vp->v_type == VNON || vp->v_writecount == 0)
-			continue;
-		if (vget(vp, LK_EXCLUSIVE, td))
-			goto again;
-		error = getinoquota(VTOI(vp));
-		if (error) {
-			vput(vp);
+	scaninfo.rescan = 1;
+	scaninfo.td = td;
+	while (scaninfo.rescan) {
+		scaninfo.rescan = 0;
+		error = vmntvnodescan(mp, NULL, quotaon_scan, &scaninfo);
+		if (error)
 			break;
-		}
-		vput(vp);
-		if (TAILQ_NEXT(vp, v_nmntvnodes) != nextvp || vp->v_mount != mp)
-			goto again;
 	}
 	ump->um_qflags[type] &= ~QTF_OPENING;
 	if (error)
@@ -460,19 +461,42 @@
 	return (error);
 }
 
+static
+int
+quotaon_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data)
+{
+	int error;
+	struct scaninfo *info = data;
+
+	if (vp->v_type == VNON || vp->v_writecount == 0) {
+		lwkt_reltoken(vlock);
+		return(0);
+	}
+	if (vget(vp, vlock, LK_INTERLOCK|LK_EXCLUSIVE, info->td)) {
+		info->rescan = 1;
+		return(0);
+	}
+	error = getinoquota(VTOI(vp));
+	vput(vp);
+	return(error);
+}
+
 /*
  * Q_QUOTAOFF - turn off disk quotas for a filesystem.
  */
+
+static int quotaoff_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data);
+
 int
 quotaoff(struct thread *td, struct mount *mp, int type)
 {
-	struct vnode *vp;
-	struct vnode *qvp, *nextvp;
+	struct vnode *qvp;
 	struct ufsmount *ump = VFSTOUFS(mp);
-	struct dquot *dq;
-	struct inode *ip;
 	struct ucred *cred;
 	int error;
+	struct scaninfo scaninfo;
 
 	KKASSERT(td->td_proc);
 	cred = td->td_proc->p_ucred;
@@ -480,24 +504,17 @@
 	if ((qvp = ump->um_quotas[type]) == NULLVP)
 		return (0);
 	ump->um_qflags[type] |= QTF_CLOSING;
+
 	/*
 	 * Search vnodes associated with this mount point,
 	 * deleting any references to quota file being closed.
 	 */
-again:
-	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nextvp) {
-		nextvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		if (vp->v_type == VNON)
-			continue;
-		if (vget(vp, LK_EXCLUSIVE, td))
-			goto again;
-		ip = VTOI(vp);
-		dq = ip->i_dquot[type];
-		ip->i_dquot[type] = NODQUOT;
-		dqrele(vp, dq);
-		vput(vp);
-		if (TAILQ_NEXT(vp, v_nmntvnodes) != nextvp || vp->v_mount != mp)
-			goto again;
+	scaninfo.rescan = 1;
+	scaninfo.td = td;
+	scaninfo.type = type;
+	while (scaninfo.rescan) {
+		scaninfo.rescan = 0;
+		vmntvnodescan(mp, NULL, quotaoff_scan, &scaninfo);
 	}
 	dqflush(qvp);
 	qvp->v_flag &= ~VSYSTEM;
@@ -506,14 +523,40 @@
 	crfree(ump->um_cred[type]);
 	ump->um_cred[type] = NOCRED;
 	ump->um_qflags[type] &= ~QTF_CLOSING;
-	for (type = 0; type < MAXQUOTAS; type++)
+	for (type = 0; type < MAXQUOTAS; type++) {
 		if (ump->um_quotas[type] != NULLVP)
 			break;
+	}
 	if (type == MAXQUOTAS)
 		mp->mnt_flag &= ~MNT_QUOTA;
 	return (error);
 }
 
+static
+int
+quotaoff_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data)
+{
+	struct scaninfo *info = data;
+	struct dquot *dq;
+	struct inode *ip;
+
+	if (vp->v_type == VNON) {
+		lwkt_reltoken(vlock);
+		return(0);
+	}
+	if (vget(vp, vlock, LK_INTERLOCK|LK_EXCLUSIVE, info->td)) {
+		info->rescan = 1;
+		return(0);
+	}
+	ip = VTOI(vp);
+	dq = ip->i_dquot[info->type];
+	ip->i_dquot[info->type] = NODQUOT;
+	dqrele(vp, dq);
+	vput(vp);
+	return(0);
+}
+
 /*
  * Q_GETQUOTA - return current values in a dqblk structure.
  */
@@ -647,15 +690,16 @@
 /*
  * Q_SYNC - sync quota files to disk.
  */
+
+static int qsync_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data);
 int
 qsync(struct mount *mp)
 {
 	struct ufsmount *ump = VFSTOUFS(mp);
 	struct thread *td = curthread;		/* XXX */
-	struct vnode *vp, *nextvp;
-	struct dquot *dq;
-	int i, error;
-	int gen;
+	struct scaninfo scaninfo;
+	int i;
 
 	/*
 	 * Check if the mount point has any quotas.
@@ -670,41 +714,44 @@
 	 * Search vnodes associated with this mount point,
 	 * synchronizing any modified dquot structures.
 	 */
-	gen = lwkt_gettoken(&mntvnode_token);
-again:
-	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nextvp) {
-		if (vp->v_mount != mp)
-			goto again;
-		nextvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		if (vp->v_type == VNON)
-			continue;
-		lwkt_gettoken(&vp->v_interlock);
-		if (lwkt_gentoken(&mntvnode_token, &gen) != 0) {
-			lwkt_reltoken(&vp->v_interlock);
-			goto again;
-		}
-		error = vget(vp, LK_EXCLUSIVE | LK_NOWAIT | LK_INTERLOCK, td);
-		if (error) {
-			if (error == ENOENT) {
-				lwkt_gentoken(&mntvnode_token, &gen);
-				goto again;
-			}
-			continue;
-		}
-		for (i = 0; i < MAXQUOTAS; i++) {
-			dq = VTOI(vp)->i_dquot[i];
-			if (dq != NODQUOT && (dq->dq_flags & DQ_MOD))
-				dqsync(vp, dq);
-		}
-		vput(vp);
-		lwkt_gentoken(&mntvnode_token, &gen);
-		if (TAILQ_NEXT(vp, v_nmntvnodes) != nextvp)
-			goto again;
+	scaninfo.rescan = 1;
+	scaninfo.td = td;
+	while (scaninfo.rescan) {
+		scaninfo.rescan = 0;
+		vmntvnodescan(mp, NULL, qsync_scan, &scaninfo);
 	}
-	lwkt_reltoken(&mntvnode_token);
 	return (0);
 }
 
+static
+int
+qsync_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data)
+{
+	struct scaninfo *info = data;
+	struct dquot *dq;
+	int error;
+	int i;
+
+	if (vp->v_type == VNON) {
+		lwkt_reltoken(vlock);
+		return(0);
+	}
+	error = vget(vp, vlock, LK_EXCLUSIVE | LK_NOWAIT | LK_INTERLOCK, info->td);
+	if (error) {
+		if (error == ENOENT)
+			info->rescan = 1;
+		return(0);
+	}
+	for (i = 0; i < MAXQUOTAS; i++) {
+		dq = VTOI(vp)->i_dquot[i];
+		if (dq != NODQUOT && (dq->dq_flags & DQ_MOD))
+			dqsync(vp, dq);
+	}
+	vput(vp);
+	return(0);
+}
+
 /*
  * Code pertaining to management of the in-core dquot data structures.
  */
@@ -800,7 +847,7 @@
 	 * Initialize the contents of the dquot structure.
 	 */
 	if (vp != dqvp)
-		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(dqvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	LIST_INSERT_HEAD(dqh, dq, dq_hash);
 	DQREF(dq);
 	dq->dq_flags = DQ_LOCK;
@@ -820,7 +867,7 @@
 	if (auio.uio_resid == sizeof(struct dqblk) && error == 0)
 		bzero((caddr_t)&dq->dq_dqb, sizeof(struct dqblk));
 	if (vp != dqvp)
-		VOP_UNLOCK(dqvp, 0, td);
+		VOP_UNLOCK(dqvp, NULL, 0, td);
 	if (dq->dq_flags & DQ_WANT)
 		wakeup((caddr_t)dq);
 	dq->dq_flags = 0;
@@ -905,13 +952,13 @@
 	if ((dqvp = dq->dq_ump->um_quotas[dq->dq_type]) == NULLVP)
 		panic("dqsync: file");
 	if (vp != dqvp)
-		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(dqvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	while (dq->dq_flags & DQ_LOCK) {
 		dq->dq_flags |= DQ_WANT;
 		(void) tsleep((caddr_t)dq, 0, "dqsync", 0);
 		if ((dq->dq_flags & DQ_MOD) == 0) {
 			if (vp != dqvp)
-				VOP_UNLOCK(dqvp, 0, td);
+				VOP_UNLOCK(dqvp, NULL, 0, td);
 			return (0);
 		}
 	}
@@ -932,7 +979,7 @@
 		wakeup((caddr_t)dq);
 	dq->dq_flags &= ~(DQ_MOD|DQ_LOCK|DQ_WANT);
 	if (vp != dqvp)
-		VOP_UNLOCK(dqvp, 0, td);
+		VOP_UNLOCK(dqvp, NULL, 0, td);
 	return (error);
 }
 
Index: vfs/ufs/ufs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ufs_vfsops.c,v
retrieving revision 1.5
diff -u -r1.5 ufs_vfsops.c
--- vfs/ufs/ufs_vfsops.c	7 Aug 2003 21:17:44 -0000	1.5
+++ vfs/ufs/ufs_vfsops.c	22 Feb 2004 06:06:07 -0000
@@ -123,7 +123,7 @@
 	type = cmds & SUBCMDMASK;
 	if ((u_int)type >= MAXQUOTAS)
 		return (EINVAL);
-	if (vfs_busy(mp, LK_NOWAIT, 0, td))
+	if (vfs_busy(mp, LK_NOWAIT, NULL, td))
 		return (0);
 
 	switch (cmd) {
Index: vfs/ufs/ufs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ufs_vnops.c,v
retrieving revision 1.10
diff -u -r1.10 ufs_vnops.c
--- vfs/ufs/ufs_vnops.c	23 Sep 2003 05:03:53 -0000	1.10
+++ vfs/ufs/ufs_vnops.c	22 Feb 2004 19:07:55 -0000
@@ -293,11 +293,12 @@
 	} */ *ap;
 {
 	struct vnode *vp = ap->a_vp;
+	lwkt_tokref vlock;
 
-	lwkt_gettoken(&vp->v_interlock);
+	lwkt_gettoken(&vlock, vp->v_interlock);
 	if (vp->v_usecount > 1)
 		ufs_itimes(vp);
-	lwkt_reltoken(&vp->v_interlock);
+	lwkt_reltoken(&vlock);
 	return (0);
 }
 
@@ -747,7 +748,7 @@
 		error = EXDEV;
 		goto out2;
 	}
-	if (tdvp != vp && (error = vn_lock(vp, LK_EXCLUSIVE, td))) {
+	if (tdvp != vp && (error = vn_lock(vp, NULL, LK_EXCLUSIVE, td))) {
 		goto out2;
 	}
 	ip = VTOI(vp);
@@ -779,7 +780,7 @@
 	}
 out1:
 	if (tdvp != vp)
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 out2:
 	VN_KNOTE(vp, NOTE_LINK);
 	VN_KNOTE(tdvp, NOTE_WRITE);
@@ -927,18 +928,18 @@
 		goto abortit;
 	}
 
-	if ((error = vn_lock(fvp, LK_EXCLUSIVE, td)) != 0)
+	if ((error = vn_lock(fvp, NULL, LK_EXCLUSIVE, td)) != 0)
 		goto abortit;
 	dp = VTOI(fdvp);
 	ip = VTOI(fvp);
 	if (ip->i_nlink >= LINK_MAX) {
-		VOP_UNLOCK(fvp, 0, td);
+		VOP_UNLOCK(fvp, NULL, 0, td);
 		error = EMLINK;
 		goto abortit;
 	}
 	if ((ip->i_flags & (NOUNLINK | IMMUTABLE | APPEND))
 	    || (dp->i_flags & APPEND)) {
-		VOP_UNLOCK(fvp, 0, td);
+		VOP_UNLOCK(fvp, NULL, 0, td);
 		error = EPERM;
 		goto abortit;
 	}
@@ -949,7 +950,7 @@
 		if ((fcnp->cn_namelen == 1 && fcnp->cn_nameptr[0] == '.') ||
 		    dp == ip || (fcnp->cn_flags | tcnp->cn_flags) & CNP_ISDOTDOT ||
 		    (ip->i_flag & IN_RENAME)) {
-			VOP_UNLOCK(fvp, 0, td);
+			VOP_UNLOCK(fvp, NULL, 0, td);
 			error = EINVAL;
 			goto abortit;
 		}
@@ -982,7 +983,7 @@
 		softdep_change_linkcnt(ip);
 	if ((error = UFS_UPDATE(fvp, !(DOINGSOFTDEP(fvp) |
 				       DOINGASYNC(fvp)))) != 0) {
-		VOP_UNLOCK(fvp, 0, td);
+		VOP_UNLOCK(fvp, NULL, 0, td);
 		goto bad;
 	}
 
@@ -997,7 +998,7 @@
 	 * call to checkpath().
 	 */
 	error = VOP_ACCESS(fvp, VWRITE, tcnp->cn_cred, tcnp->cn_td);
-	VOP_UNLOCK(fvp, 0, td);
+	VOP_UNLOCK(fvp, NULL, 0, td);
 	if (oldparent != dp->i_number)
 		newparent = dp->i_number;
 	if (doingdirectory && newparent) {
@@ -1215,7 +1216,7 @@
 out:
 	if (doingdirectory)
 		ip->i_flag &= ~IN_RENAME;
-	if (vn_lock(fvp, LK_EXCLUSIVE, td) == 0) {
+	if (vn_lock(fvp, NULL, LK_EXCLUSIVE, td) == 0) {
 		ip->i_effnlink--;
 		ip->i_nlink--;
 		ip->i_flag |= IN_CHANGE;
@@ -1841,11 +1842,12 @@
 	} */ *ap;
 {
 	struct vnode *vp = ap->a_vp;
+	lwkt_tokref vlock;
 
-	lwkt_gettoken(&vp->v_interlock);
+	lwkt_gettoken(&vlock, vp->v_interlock);
 	if (vp->v_usecount > 1)
 		ufs_itimes(vp);
-	lwkt_reltoken(&vp->v_interlock);
+	lwkt_reltoken(&vlock);
 	return (VOCALL(spec_vnodeop_p, VOFFSET(vop_close), ap));
 }
 
@@ -1915,11 +1917,12 @@
 	} */ *ap;
 {
 	struct vnode *vp = ap->a_vp;
+	lwkt_tokref vlock;
 
-	lwkt_gettoken(&vp->v_interlock);
+	lwkt_gettoken(&vlock, vp->v_interlock);
 	if (vp->v_usecount > 1)
 		ufs_itimes(vp);
-	lwkt_reltoken(&vp->v_interlock);
+	lwkt_reltoken(&vlock);
 	return (VOCALL(fifo_vnodeop_p, VOFFSET(vop_close), ap));
 }
 
@@ -2188,6 +2191,7 @@
 {
 	struct vnode *vp = ap->a_vp;
 	struct knote *kn = ap->a_kn;
+	lwkt_tokref ilock;
 
 	switch (kn->kn_filter) {
 	case EVFILT_READ:
@@ -2205,9 +2209,9 @@
 
 	kn->kn_hook = (caddr_t)vp;
 
-	lwkt_gettoken(&vp->v_pollinfo.vpi_token);
+	lwkt_gettoken(&ilock, &vp->v_pollinfo.vpi_token);
 	SLIST_INSERT_HEAD(&vp->v_pollinfo.vpi_selinfo.si_note, kn, kn_selnext);
-	lwkt_reltoken(&vp->v_pollinfo.vpi_token);
+	lwkt_reltoken(&ilock);
 
 	return (0);
 }
@@ -2216,11 +2220,12 @@
 filt_ufsdetach(struct knote *kn)
 {
 	struct vnode *vp = (struct vnode *)kn->kn_hook;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&vp->v_pollinfo.vpi_token);
+	lwkt_gettoken(&ilock, &vp->v_pollinfo.vpi_token);
 	SLIST_REMOVE(&vp->v_pollinfo.vpi_selinfo.si_note,
 	    kn, knote, kn_selnext);
-	lwkt_reltoken(&vp->v_pollinfo.vpi_token);
+	lwkt_reltoken(&ilock);
 }
 
 /*ARGSUSED*/
Index: vfs/umapfs/umap_subr.c
===================================================================
RCS file: /cvs/src/sys/vfs/umapfs/umap_subr.c,v
retrieving revision 1.5
diff -u -r1.5 umap_subr.c
--- vfs/umapfs/umap_subr.c	20 Aug 2003 09:56:34 -0000	1.5
+++ vfs/umapfs/umap_subr.c	22 Feb 2004 06:17:17 -0000
@@ -168,7 +168,7 @@
 			 * stuff, but we don't want to lock
 			 * the lower node.
 			 */
-			if (vget(vp, 0, td)) {
+			if (vget(vp, NULL, 0, td)) {
 #ifdef DEBUG
 				printf ("umap_node_find: vget failed.\n");
 #endif
Index: vfs/umapfs/umap_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/umapfs/umap_vfsops.c,v
retrieving revision 1.8
diff -u -r1.8 umap_vfsops.c
--- vfs/umapfs/umap_vfsops.c	23 Sep 2003 05:03:54 -0000	1.8
+++ vfs/umapfs/umap_vfsops.c	22 Feb 2004 06:00:43 -0000
@@ -204,7 +204,7 @@
 	/*
 	 * Unlock the node (either the lower or the alias)
 	 */
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	/*
 	 * Make sure the node alias worked
 	 */
@@ -307,7 +307,7 @@
 	 */
 	vp = MOUNTTOUMAPMOUNT(mp)->umapm_rootvp;
 	VREF(vp);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	*vpp = vp;
 	return (0);
 }
Index: vfs/umapfs/umap_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/umapfs/umap_vnops.c,v
retrieving revision 1.5
diff -u -r1.5 umap_vnops.c
--- vfs/umapfs/umap_vnops.c	20 Aug 2003 09:56:34 -0000	1.5
+++ vfs/umapfs/umap_vnops.c	22 Feb 2004 06:22:08 -0000
@@ -359,6 +359,7 @@
 umap_lock(ap)
 	struct vop_lock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct thread *a_td;
 	} */ *ap;
@@ -407,7 +408,7 @@
 	 *
 	 */
 	VOP_INACTIVE(lowervp, ap->a_td);
-	VOP_UNLOCK(ap->a_vp, 0, ap->a_td);
+	VOP_UNLOCK(ap->a_vp, NULL, 0, ap->a_td);
 	return (0);
 }
 
Index: vfs/union/union_subr.c
===================================================================
RCS file: /cvs/src/sys/vfs/union/union_subr.c,v
retrieving revision 1.9
diff -u -r1.9 union_subr.c
--- vfs/union/union_subr.c	9 Oct 2003 22:27:27 -0000	1.9
+++ vfs/union/union_subr.c	22 Feb 2004 06:17:29 -0000
@@ -403,7 +403,7 @@
 			    (un->un_uppervp == uppervp ||
 			     un->un_uppervp == NULLVP) &&
 			    (UNIONTOV(un)->v_mount == mp)) {
-				if (vget(UNIONTOV(un), 0,
+				if (vget(UNIONTOV(un), NULL, 0,
 				    cnp ? cnp->cn_td : NULL)) {
 					union_list_unlock(hash);
 					goto loop;
@@ -444,21 +444,21 @@
 				 * while moving up the tree).
 				 */
 				VREF(dvp);
-				VOP_UNLOCK(dvp, 0, td);
-				error = vn_lock(un->un_vnode, LK_EXCLUSIVE, td);
-				vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
+				error = vn_lock(un->un_vnode, NULL, LK_EXCLUSIVE, td);
+				vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 				vrele(dvp);
 			} else {
 				/*
 				 * our new un is under dvp
 				 */
-				error = vn_lock(un->un_vnode, LK_EXCLUSIVE, td);
+				error = vn_lock(un->un_vnode, NULL, LK_EXCLUSIVE, td);
 			}
 		} else if (dvp == NULLVP) {
 			/*
 			 * dvp is NULL, we need to lock un.
 			 */
-			error = vn_lock(un->un_vnode, LK_EXCLUSIVE, td);
+			error = vn_lock(un->un_vnode, NULL, LK_EXCLUSIVE, td);
 		} else {
 			/*
 			 * dvp == un->un_vnode, we are already locked.
@@ -567,7 +567,7 @@
 	bzero(un, sizeof(*un));
 
 	lockinit(&un->un_lock, 0, "unlock", VLKTIMEOUT, 0);
-	vn_lock(*vpp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(*vpp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 	un->un_vnode = *vpp;
 	un->un_uppervp = uppervp;
@@ -749,9 +749,9 @@
 	 * If the user does not have read permission, the vnode should not
 	 * be copied to upper layer.
 	 */
-	vn_lock(un->un_lowervp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(un->un_lowervp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_ACCESS(un->un_lowervp, VREAD, cred, td);
-	VOP_UNLOCK(un->un_lowervp, 0, td);
+	VOP_UNLOCK(un->un_lowervp, NULL, 0, td);
 	if (error)
 		return (error);
 
@@ -767,20 +767,20 @@
 		 * XX - should not ignore errors
 		 * from VOP_CLOSE
 		 */
-		vn_lock(lvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(lvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		error = VOP_OPEN(lvp, FREAD, cred, td);
 		if (error == 0 && vn_canvmio(lvp) == TRUE)
 			error = vfs_object_create(lvp, td);
 		if (error == 0) {
 			error = union_copyfile(lvp, uvp, cred, td);
-			VOP_UNLOCK(lvp, 0, td);
+			VOP_UNLOCK(lvp, NULL, 0, td);
 			(void) VOP_CLOSE(lvp, FREAD, td);
 		}
 		if (error == 0)
 			UDEBUG(("union: copied up %s\n", un->un_path));
 
 	}
-	VOP_UNLOCK(uvp, 0, td);
+	VOP_UNLOCK(uvp, NULL, 0, td);
 	union_newupper(un, uvp);
 	KASSERT(uvp->v_usecount > 0, ("copy: uvp refcount 0: %d", uvp->v_usecount));
 	union_vn_close(uvp, FWRITE, cred, td);
@@ -860,7 +860,7 @@
 	cn->cn_consume = cnp->cn_consume;
 
 	VREF(dvp);
-	VOP_UNLOCK(dvp, 0, cnp->cn_td);
+	VOP_UNLOCK(dvp, NULL, 0, cnp->cn_td);
 
 	/*
 	 * Pass dvp unlocked and referenced on call to relookup().
@@ -869,7 +869,7 @@
 	 */
 
 	if ((error = relookup(dvp, vpp, cn)) != 0) {
-		vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, cnp->cn_td);
+		vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, cnp->cn_td);
 		return(error);
 	}
 
@@ -1224,7 +1224,7 @@
 	struct union_node *un;
 	int error;
 
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	dircache = VTOUNION(vp)->un_dircache;
 
 	nvp = NULLVP;
@@ -1250,7 +1250,7 @@
 	if (*vpp == NULLVP)
 		goto out;
 
-	/*vn_lock(*vpp, LK_EXCLUSIVE | LK_RETRY, td);*/
+	/*vn_lock(*vpp, NULL, LK_EXCLUSIVE | LK_RETRY, td);*/
 	UDEBUG(("ALLOCVP-3 %p ref %d\n", *vpp, (*vpp ? (*vpp)->v_usecount : -99)));
 	VREF(*vpp);
 	error = union_allocvp(&nvp, vp->v_mount, NULLVP, NULLVP, NULL, *vpp, NULLVP, 0);
@@ -1263,7 +1263,7 @@
 	un->un_dircache = dircache;
 
 out:
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (nvp);
 }
 
@@ -1335,7 +1335,7 @@
 				vput(lvp);
 				return (error);
 			}
-			VOP_UNLOCK(lvp, 0, td);
+			VOP_UNLOCK(lvp, NULL, 0, td);
 			fp->f_data = (caddr_t) lvp;
 			fp->f_offset = 0;
 			error = vn_close(*vp, FREAD, td);
Index: vfs/union/union_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/union/union_vfsops.c,v
retrieving revision 1.7
diff -u -r1.7 union_vfsops.c
--- vfs/union/union_vfsops.c	9 Oct 2003 22:27:27 -0000	1.7
+++ vfs/union/union_vfsops.c	22 Feb 2004 19:59:11 -0000
@@ -129,7 +129,7 @@
 	 * Unlock lower node to avoid deadlock.
 	 */
 	if (lowerrootvp->v_op == union_vnodeop_p)
-		VOP_UNLOCK(lowerrootvp, 0, td);
+		VOP_UNLOCK(lowerrootvp, NULL, 0, td);
 #endif
 
 	/*
@@ -143,7 +143,7 @@
 
 #if 0
 	if (lowerrootvp->v_op == union_vnodeop_p)
-		vn_lock(lowerrootvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(lowerrootvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 #endif
 	if (error)
 		goto bad;
@@ -341,6 +341,8 @@
 		for (n = 0, vp = TAILQ_FIRST(&mp->mnt_nvnodelist);
 		    vp != NULLVP;
 		    vp = TAILQ_NEXT(vp, v_nmntvnodes)) {
+			if (vp->v_flag & VPLACEMARKER)	/* ZZZ */
+				continue;
 			n++;
 		}
 
Index: vfs/union/union_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/union/union_vnops.c,v
retrieving revision 1.9
diff -u -r1.9 union_vnops.c
--- vfs/union/union_vnops.c	9 Oct 2003 22:27:27 -0000	1.9
+++ vfs/union/union_vnops.c	22 Feb 2004 06:24:12 -0000
@@ -116,7 +116,7 @@
 
 	if ((uppervp = un->un_uppervp) != NULL) {
 		VREF(uppervp);
-		vn_lock(uppervp, LK_EXCLUSIVE | LK_CANRECURSE | LK_RETRY, td);
+		vn_lock(uppervp, NULL, LK_EXCLUSIVE | LK_CANRECURSE | LK_RETRY, td);
 	}
 	KASSERT((uppervp == NULL || uppervp->v_usecount > 0), ("uppervp usecount is 0"));
 	return(uppervp);
@@ -139,7 +139,7 @@
 		vp = union_lock_upper(un, td);
 	} else if ((vp = un->un_lowervp) != NULL) {
 		VREF(vp);
-		vn_lock(vp, LK_EXCLUSIVE | LK_CANRECURSE | LK_RETRY, td);
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_CANRECURSE | LK_RETRY, td);
 	}
 	return(vp);
 }
@@ -202,7 +202,7 @@
 			dvp = dvp->v_mount->mnt_vnodecovered;
 			VREF(dvp);
 			vput(tdvp);
-			vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		}
 	}
 
@@ -233,7 +233,7 @@
 	UDEBUG(("parentdir %p result %p flag %lx\n", dvp, tdvp, cnp->cn_flags));
 
 	if (dvp != tdvp && (cnp->cn_flags & CNP_ISLASTCN) == 0)
-		vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 	/*
 	 * Lastly check if the current node is a mount point in
@@ -253,7 +253,7 @@
 	) {
 		int relock_pdvp = 0;
 
-		if (vfs_busy(mp, 0, 0, td))
+		if (vfs_busy(mp, 0, NULL, td))
 			continue;
 
 		if (dvp == *pdvp)
@@ -265,7 +265,7 @@
 		vfs_unbusy(mp, td);
 
 		if (relock_pdvp)
-			vn_lock(*pdvp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(*pdvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 		if (error) {
 			*vpp = NULL;
@@ -446,7 +446,7 @@
 		 * to us so we NULL it out.
 		 */
 		VREF(lowerdvp);
-		vn_lock(lowerdvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(lowerdvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		lerror = union_lookup1(um->um_lowervp, &lowerdvp, &lowervp, cnp);
 		if (lowerdvp == lowervp)
 			vrele(lowerdvp);
@@ -470,7 +470,7 @@
 		if ((cnp->cn_flags & CNP_ISDOTDOT) && dun->un_pvp != NULLVP) {
 			if ((lowervp = LOWERVP(dun->un_pvp)) != NULL) {
 				VREF(lowervp);
-				vn_lock(lowervp, LK_EXCLUSIVE | LK_RETRY, td);
+				vn_lock(lowervp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 				lerror = 0;
 			}
 		}
@@ -533,11 +533,11 @@
 	 */
 
 	if (uppervp && uppervp != upperdvp)
-		VOP_UNLOCK(uppervp, 0, td);
+		VOP_UNLOCK(uppervp, NULL, 0, td);
 	if (lowervp)
-		VOP_UNLOCK(lowervp, 0, td);
+		VOP_UNLOCK(lowervp, NULL, 0, td);
 	if (upperdvp)
-		VOP_UNLOCK(upperdvp, 0, td);
+		VOP_UNLOCK(upperdvp, NULL, 0, td);
 
 	error = union_allocvp(ap->a_vpp, dvp->v_mount, dvp, upperdvp, cnp,
 			      uppervp, lowervp, 1);
@@ -600,7 +600,7 @@
 	if (*ap->a_vpp != dvp) {
 		if ((error == 0 || error == EJUSTRETURN) &&
 		    (!lockparent || (cnp->cn_flags & CNP_ISLASTCN) == 0)) {
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 		}
 	}
 
@@ -648,7 +648,7 @@
 		error = VOP_CREATE(dvp, NCPNULL, &vp, cnp, ap->a_vap);
 		if (error == 0) {
 			mp = ap->a_dvp->v_mount;
-			VOP_UNLOCK(vp, 0, td);
+			VOP_UNLOCK(vp, NULL, 0, td);
 			UDEBUG(("ALLOCVP-1 FROM %p REFS %d\n", vp, vp->v_usecount));
 			error = union_allocvp(ap->a_vpp, mp, NULLVP, NULLVP,
 				cnp, vp, NULLVP, 1);
@@ -756,7 +756,7 @@
 		} else {
 			un->un_openl++;
 			VREF(tvp);
-			vn_lock(tvp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(tvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			tvpisupper = 0;
 		}
 	}
@@ -864,7 +864,7 @@
 	}
 
 	if ((vp = un->un_lowervp) != NULLVP) {
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		ap->a_vp = vp;
 
 		/*
@@ -885,7 +885,7 @@
 				error = VCALL(vp, VOFFSET(vop_access), ap);
 			}
 		}
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 	}
 	return(error);
 }
@@ -1317,24 +1317,24 @@
 		struct union_node *tun = VTOUNION(ap->a_vp);
 
 		if (tun->un_uppervp == NULLVP) {
-			vn_lock(ap->a_vp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(ap->a_vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 #if 0
 			if (dun->un_uppervp == tun->un_dirvp) {
 				if (dun->un_flags & UN_ULOCK) {
 					dun->un_flags &= ~UN_ULOCK;
-					VOP_UNLOCK(dun->un_uppervp, 0, td);
+					VOP_UNLOCK(dun->un_uppervp, NULL, 0, td);
 				}
 			}
 #endif
 			error = union_copyup(tun, 1, cnp->cn_cred, td);
 #if 0
 			if (dun->un_uppervp == tun->un_dirvp) {
-				vn_lock(dun->un_uppervp,
+				vn_lock(dun->un_uppervp, NULL,
 					    LK_EXCLUSIVE | LK_RETRY, td);
 				dun->un_flags |= UN_ULOCK;
 			}
 #endif
-			VOP_UNLOCK(ap->a_vp, 0, td);
+			VOP_UNLOCK(ap->a_vp, NULL, 0, td);
 		}
 		vp = tun->un_uppervp;
 	}
@@ -1352,15 +1352,15 @@
 	if ((tdvp = union_lock_upper(dun, td)) == NULLVP)
 		return (EROFS);
 
-	VOP_UNLOCK(ap->a_tdvp, 0, td);		/* unlock calling node */
-	error = VOP_LINK(tdvp, NCPNULL, vp, cnp);	/* call link on upper */
+	VOP_UNLOCK(ap->a_tdvp, NULL, 0, td);	/* unlock calling node */
+	error = VOP_LINK(tdvp, NCPNULL, vp, cnp); /* call link on upper */
 
 	/*
 	 * We have to unlock tdvp prior to relocking our calling node in
 	 * order to avoid a deadlock.
 	 */
 	union_unlock_upper(tdvp, td);
-	vn_lock(ap->a_tdvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(ap->a_tdvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	return (error);
 }
 
@@ -1417,9 +1417,9 @@
 		if (un->un_uppervp == NULLVP) {
 			switch(fvp->v_type) {
 			case VREG:
-				vn_lock(un->un_vnode, LK_EXCLUSIVE | LK_RETRY, ap->a_fcnp->cn_td);
+				vn_lock(un->un_vnode, NULL, LK_EXCLUSIVE | LK_RETRY, ap->a_fcnp->cn_td);
 				error = union_copyup(un, 1, ap->a_fcnp->cn_cred, ap->a_fcnp->cn_td);
-				VOP_UNLOCK(un->un_vnode, 0, ap->a_fcnp->cn_td);
+				VOP_UNLOCK(un->un_vnode, NULL, 0, ap->a_fcnp->cn_td);
 				if (error)
 					goto bad;
 				break;
@@ -1435,12 +1435,12 @@
 #if 0
 				vrele(fvp);
 				fvp = NULL;
-				vn_lock(fdvp, LK_EXCLUSIVE | LK_RETRY, ap->a_fcnp->cn_td);
+				vn_lock(fdvp, NULL, LK_EXCLUSIVE | LK_RETRY, ap->a_fcnp->cn_td);
 				error = union_mkshadow(um, fdvp, 
 					    ap->a_fcnp, &un->un_uppervp);
-				VOP_UNLOCK(fdvp, 0, ap->a_fcnp->cn_td);
+				VOP_UNLOCK(fdvp, NULL, 0, ap->a_fcnp->cn_td);
 				if (un->un_uppervp)
-					VOP_UNLOCK(un->un_uppervp, 0, ap->a_fcnp->cn_td);
+					VOP_UNLOCK(un->un_uppervp, NULL, 0, ap->a_fcnp->cn_td);
 				if (error)
 					goto bad;
 				break;
@@ -1551,7 +1551,7 @@
 		union_unlock_upper(upperdvp, td);
 
 		if (error == 0) {
-			VOP_UNLOCK(vp, 0, td);
+			VOP_UNLOCK(vp, NULL, 0, td);
 			UDEBUG(("ALLOCVP-2 FROM %p REFS %d\n", vp, vp->v_usecount));
 			error = union_allocvp(ap->a_vpp, ap->a_dvp->v_mount,
 				ap->a_dvp, NULLVP, cnp, vp, NULLVP, 1);
@@ -1721,11 +1721,11 @@
 #if 0
 	if ((un->un_flags & UN_ULOCK) && un->un_uppervp) {
 		un->un_flags &= ~UN_ULOCK;
-		VOP_UNLOCK(un->un_uppervp, 0, td);
+		VOP_UNLOCK(un->un_uppervp, NULL, 0, td);
 	}
 #endif
 
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 
 	if ((un->un_flags & UN_CACHED) == 0)
 		vgone(vp);
@@ -1768,10 +1768,12 @@
 		if (un->un_uppervp != NULLVP && 
 		    (flags & LK_TYPE_MASK) == LK_EXCLUSIVE) {
 			if ((un->un_flags & UN_ULOCK) == 0 && vp->v_usecount) {
-				error = vn_lock(un->un_uppervp, flags, td);
+				error = vn_lock(un->un_uppervp, ap->a_vlock,
+						flags, td);
 				if (error) {
 					struct vop_unlock_args uap = { 0 };
 					uap.a_vp = ap->a_vp;
+					uap.a_vlock = ap->a_vlock;
 					uap.a_flags = ap->a_flags;
 					uap.a_td = ap->a_td;
 					vop_stdunlock(&uap);
@@ -1794,6 +1796,7 @@
 union_unlock(ap)
 	struct vop_unlock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct thread *a_td;
 	} */ *ap;
@@ -1816,7 +1819,7 @@
 	if ((un->un_flags & UN_ULOCK) && 
 	    lockstatus(&un->un_lock, NULL) != LK_EXCLUSIVE) {
 		un->un_flags &= ~UN_ULOCK;
-		VOP_UNLOCK(un->un_uppervp, LK_EXCLUSIVE, td);
+		VOP_UNLOCK(un->un_uppervp, NULL, LK_EXCLUSIVE, td);
 	}
 #endif
 	return(error);
Index: vm/vm_contig.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_contig.c,v
retrieving revision 1.5
diff -u -r1.5 vm_contig.c
--- vm/vm_contig.c	18 Feb 2004 16:28:21 -0000	1.5
+++ vm/vm_contig.c	22 Feb 2004 06:02:28 -0000
@@ -126,10 +126,10 @@
 		if (m->dirty) {
 			object = m->object;
 			if (object->type == OBJT_VNODE) {
-				vn_lock(object->handle, LK_EXCLUSIVE | LK_RETRY,
-					curthread);
+				vn_lock(object->handle, NULL,
+					LK_EXCLUSIVE | LK_RETRY, curthread);
 				vm_object_page_clean(object, 0, 0, OBJPC_SYNC);
-				VOP_UNLOCK(object->handle, 0, curthread);
+				VOP_UNLOCK(object->handle, NULL, 0, curthread);
 				return (TRUE);
 			} else if (object->type == OBJT_SWAP ||
 					object->type == OBJT_DEFAULT) {
Index: vm/vm_extern.h
===================================================================
RCS file: /cvs/src/sys/vm/vm_extern.h,v
retrieving revision 1.9
diff -u -r1.9 vm_extern.h
--- vm/vm_extern.h	20 Jan 2004 18:41:52 -0000	1.9
+++ vm/vm_extern.h	23 Feb 2004 00:21:38 -0000
@@ -70,7 +70,6 @@
 void kmem_free (vm_map_t, vm_offset_t, vm_size_t);
 void kmem_free_wakeup (vm_map_t, vm_offset_t, vm_size_t);
 void kmem_init (vm_offset_t, vm_offset_t);
-void kmem_cpu_init (void);
 vm_offset_t kmem_malloc (vm_map_t, vm_size_t, boolean_t);
 vm_map_t kmem_suballoc (vm_map_t, vm_offset_t *, vm_offset_t *, vm_size_t);
 void munmapfd (struct proc *, int);
Index: vm/vm_fault.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_fault.c,v
retrieving revision 1.10
diff -u -r1.10 vm_fault.c
--- vm/vm_fault.c	20 Jan 2004 05:04:08 -0000	1.10
+++ vm/vm_fault.c	22 Feb 2004 05:26:34 -0000
@@ -649,7 +649,7 @@
 				 * grab the lock if we need to
 				 */
 				(fs.lookup_still_valid ||
-				 lockmgr(&fs.map->lock, LK_EXCLUSIVE|LK_NOWAIT, (void *)0, curthread) == 0)
+				 lockmgr(&fs.map->lock, LK_EXCLUSIVE|LK_NOWAIT, NULL, curthread) == 0)
 			    ) {
 				
 				fs.lookup_still_valid = 1;
Index: vm/vm_glue.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_glue.c,v
retrieving revision 1.19
diff -u -r1.19 vm_glue.c
--- vm/vm_glue.c	14 Jan 2004 23:26:14 -0000	1.19
+++ vm/vm_glue.c	22 Feb 2004 05:26:41 -0000
@@ -498,7 +498,7 @@
 			 */
 			if (lockmgr(&vm->vm_map.lock,
 					LK_EXCLUSIVE | LK_NOWAIT,
-					(void *)0, curthread)) {
+					NULL, curthread)) {
 				vmspace_free(vm);
 				continue;
 			}
Index: vm/vm_init.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_init.c,v
retrieving revision 1.4
diff -u -r1.4 vm_init.c
--- vm/vm_init.c	27 Aug 2003 01:43:08 -0000	1.4
+++ vm/vm_init.c	23 Feb 2004 03:38:00 -0000
@@ -113,7 +113,6 @@
 	vm_object_init();
 	vm_map_startup();
 	kmem_init(virtual_avail, virtual_end);
-	kmem_cpu_init();
 	pmap_init(avail_start, avail_end);
 	vm_pager_init();
 }
Index: vm/vm_kern.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_kern.c,v
retrieving revision 1.14
diff -u -r1.14 vm_kern.c
--- vm/vm_kern.c	20 Jan 2004 05:04:08 -0000	1.14
+++ vm/vm_kern.c	23 Feb 2004 00:18:43 -0000
@@ -536,17 +536,3 @@
 	vm_map_entry_release(count);
 }
 
-/*
- *	kmem_cpu_init:
- *
- *	Load up extra vm_map_entry structures in each cpu's globaldata
- *	cache.  These allow us to expand the mapent zone for kernel_map.
- *	Without them we would get into a recursion deadlock trying to
- *	reserve map entries (reserve->zalloc->kmem_alloc->reserve->...)
- */
-void
-kmem_cpu_init(void)
-{
-	vm_map_entry_reserve(MAP_RESERVE_COUNT * 2);
-}
-
